create or replace
PROCEDURE EXPORTA_NF_ENTRADA_SAP(P_DATAINI   IN DATE,
                                   P_DATAFINAL IN DATE,
                                   P_CDFILIAL  IN VARCHAR2,
                                   P_TCDFILIAL IN CHAR,
                                   P_NUMERORE  IN VARCHAR2 DEFAULT NULL,
                                   P_IDTELAEXP IN CHAR DEFAULT 'N')
IS
   V_VERFILIAL  INTEGER;
   V_FILIAL     VARCHAR2(4);
   V_NRLANCORIG VARCHAR2(20);
   V_SERNFORIG  VARCHAR2(5);
   V_FILIORIG   VARCHAR2(4);
   V_FILIDEST   VARCHAR2(4);
   V_FILIALTG   VARCHAR2(4);
   V_FECHDIA    VARCHAR2(1);
   V_DSREMOTEADDR VARCHAR2(15);
   V_DSREMOTEHOST VARCHAR2(15);
   V_DSSERVERRDM  VARCHAR2(20);
   V_DSSERVMETHOD VARCHAR2(30);
   V_DSREMOTEOPER VARCHAR2(12);
   V_CDARVPROD    VARCHAR2(20);
   V_NRPROTOCOLONFE VARCHAR2(15);
   V_DTAUTPROTOCOLO VARCHAR2(12);
   V_HRAUTPROTOCOLO VARCHAR2(12);
   
   -- Diferenca da nota para a AF
   V_VRTOTALAF    FLOAT;
   V_VRDIFENFAF   FLOAT;
   BOAF           BOOLEAN;
   V_VRUNITAF     FLOAT;
   V_VRTOTAITEMAF FLOAT;
   V_VRDIFEITNFAF FLOAT;
   V_QTDEPRODAF   FLOAT;
   
   V_IMPOSTO_ACR  FLOAT;
   V_IMPOSTO_DEC  FLOAT;

   V_CDPRODUTO    VARCHAR2(10);
   V_CDFORNECED   VARCHAR2(21);
   
   -- GRAVA OS NUMEROS DAS AFS QUE COMPOEM A NOTA FISCAL
   V_CDFILDESTINO VARCHAR2(4000);
   V_CDFILLANCAME VARCHAR2(4000);
   V_NRAUTOFORNE  VARCHAR2(4000);
   V_NUMEROAF     VARCHAR2(4000);
   V_CDFILDEST    VARCHAR2(4000);
   V_CDFILLANC    VARCHAR2(4000);
   V_VRTOTITEM_CALC  FLOAT;
   V_VRUNITITEM_CALC FLOAT;
   
   V_VRTOTDIFNEGATIVO FLOAT;
   V_VRTOTDIFPOSITIVO FLOAT;
   
   FUNCTION GET_FILIALTG(V_FILIAL VARCHAR2, V_NRLANCTO VARCHAR2) RETURN VARCHAR2
   IS
      V_RETORNO VARCHAR2(6);
   BEGIN
      SELECT MAX(DECODE(N.IDENTRSAIDOP, NULL, NVL(NVL(P.CDEXFILIAL,N.CDFILIAL),'    '),
                        DECODE(P.IDTIPODADOTG, 'L', NVL(SUBSTR(I.CDLOCALESTOQ, -4),'    '), 
                                               'A', NVL(SUBSTR(I.CDALMOXARIFE, -4),'    '),
                                               NVL(NVL(P.CDEXFILIAL,N.CDFILIRECE),'    ')
                               )
                        )
                 ) CDFILIALTG
        INTO V_RETORNO
        FROM NOTAFISCAL N, ITEMPRODUTO I, PARAMFILIAL P
       WHERE (N.CDFILIAL   = V_FILIAL)
         AND (N.NRLANCTONF = V_NRLANCTO)
         AND (N.CDFILIAL   = I.CDFILIAL)
         AND (N.NRLANCTONF = I.NRLANCTONF)
         AND (N.CDFILIRECE = P.CDFILIAL);
      RETURN V_RETORNO;
   END;
   
   FUNCTION GET_PRODUTO(P_CDPRODUTO VARCHAR2, P_FUNCAOFILI VARCHAR2) RETURN VARCHAR2
   IS
      V_CDPROD  VARCHAR2(20);
      V_RETORNO VARCHAR2(20);
   BEGIN
      IF (P_FUNCAOFILI = 'O') THEN
         SELECT MIN(CDPRARVORIG) CDPRARVORIG
           INTO V_CDPROD
           FROM RELACPRODOL
          WHERE CDPRODARVOL = P_CDPRODUTO;
          
         IF (V_CDPROD IS NULL) THEN
            V_CDPROD := P_CDPRODUTO;
         END IF;
      ELSE
         V_CDPROD := P_CDPRODUTO;
      END IF;
      
      SELECT CDARVPROD
        INTO V_RETORNO
        FROM PRODUTO
       WHERE CDPRODUTO = V_CDPROD;

      RETURN V_RETORNO;
   END;
   
   FUNCTION PRODUTO_AF(P_CDARVPROD IN VARCHAR2) RETURN VARCHAR2
   IS
      V_CDPRODUTO VARCHAR2(10);
   BEGIN
      SELECT CDPRODUTO
        INTO V_CDPRODUTO
        FROM PRODUTO
       WHERE CDARVPROD = P_CDARVPROD;
       
      RETURN V_CDPRODUTO;
   END;
   
   PROCEDURE VERIFICA_AF(P_CDFILIAL IN VARCHAR2, P_NRLANCTONF IN VARCHAR2, P_IDFUNCAOFILI IN VARCHAR2)
   IS
      V_CDPRODUTO   VARCHAR2(10);
      V_QTITEMPROD  FLOAT;
      V_VRPREUNIAF  FLOAT;
      V_QTPROGENTAF FLOAT;
      V_CDMARCA     VARCHAR2(5);
      
      V_ARVPRODUTO VARCHAR2(20);
      V_CDPRODCONV VARCHAR2(10); -- CODIGO DO PRODUTO. NOS CASOS DE OL ESSE PRODUTO VAI SER O RELACIONADO E NAO O PRODUTO DA NOTA
      
      V_CDFILDEST    VARCHAR2(4);
      V_CDFILLANC    VARCHAR2(4);
      V_NRAUTOFORN   VARCHAR2(10);
      
      CURSOR C_ITEMPRODUTO(C_CDFILIAL IN VARCHAR2, C_NRLANCTONF IN VARCHAR2) IS
         SELECT CDPRODUTO, CDMARCA, SUM(QTITEMPROD)
           FROM ITEMPRODUTO
          WHERE CDFILIAL   = C_CDFILIAL
            AND NRLANCTONF = C_NRLANCTONF
          GROUP BY CDPRODUTO, CDMARCA;
      
      CURSOR C_AUTOFORN(C_CDFILIAL IN VARCHAR2, C_NRLANCTONF IN VARCHAR2) IS
         SELECT DISTINCT CDFILDEST, CDFILLANC, NRAUTOFORN
           FROM NFRELACAF
          WHERE CDFILIAL   = C_CDFILIAL
            AND NRLANCTONF = C_NRLANCTONF;
   BEGIN
      OPEN C_AUTOFORN(P_CDFILIAL ,P_NRLANCTONF);
      LOOP
         FETCH C_AUTOFORN INTO V_CDFILDEST, V_CDFILLANC, V_NRAUTOFORN;
         EXIT WHEN C_AUTOFORN%NOTFOUND;
         
         BOAF := TRUE;
         V_CDFILDESTINO := V_CDFILDESTINO||V_CDFILDEST||',';
         V_CDFILLANCAME := V_CDFILLANCAME||V_CDFILLANC||',';
         V_NRAUTOFORNE  := V_NRAUTOFORNE||V_NRAUTOFORN||',';
         
         OPEN C_ITEMPRODUTO(P_CDFILIAL ,P_NRLANCTONF);
         LOOP
            FETCH C_ITEMPRODUTO INTO V_CDPRODUTO, V_CDMARCA, V_QTITEMPROD;
            EXIT WHEN C_ITEMPRODUTO%NOTFOUND;
            
            BEGIN -- PROCURA O VALOR DO PRODUTO NA AF NOS CASOS EM QUE A AF FOI GERADA COM OS MESMOS PRODUTOS DA NOTA
                      -- MEDIA DO PRECO DA AF CASO POSSUA MAIS DE UM PRODUTO COM MARCAS DIFERENTES
               SELECT AVG(VRPREUNIAF), SUM(QTEFETENTRAF)--, SUM(QTPROGENTAF)
                 INTO V_VRPREUNIAF, V_QTPROGENTAF
                 FROM ITEMAUTF
                WHERE CDFILDEST  = V_CDFILDEST
                  AND CDFILLANC  = V_CDFILLANC
                  AND NRAUTOFORN = V_NRAUTOFORN
                  AND CDPRODUTO  = V_CDPRODUTO
                  AND CDMARCA    = V_CDMARCA;
            EXCEPTION
               WHEN OTHERS THEN
                  BEGIN -- PROCURA O VALOR DO PRODUTO NA AF NOS CASOS EM QUE A AF TENHA SIDO GERADA COM OS PRODUTOS RELACIONADOS
                     V_ARVPRODUTO := GET_PRODUTO(V_CDPRODUTO, P_IDFUNCAOFILI);
                     V_CDPRODCONV := PRODUTO_AF(V_ARVPRODUTO);
                     SELECT AVG(VRPREUNIAF), SUM(QTEFETENTRAF)--, SUM(QTPROGENTAF)
                       INTO V_VRPREUNIAF, V_QTPROGENTAF
                       FROM ITEMAUTF
                      WHERE CDFILDEST  = V_CDFILDEST
                        AND CDFILLANC  = V_CDFILLANC
                        AND NRAUTOFORN = V_NRAUTOFORN
                        AND CDPRODUTO  = V_CDPRODCONV
                        AND CDMARCA    = V_CDMARCA;
                  EXCEPTION
                     WHEN OTHERS THEN
                        -- CASO O PRODUTO DA NF NAO TENHA VINCULO COM NENHUM PRODUTO DA AF, O VALOR DE VRPREUNIAF SERA 0 (ZERO)
                        V_VRPREUNIAF := 0;
                  END;
            END;
            
            /*IF (V_QTITEMPROD > V_QTPROGENTAF) THEN
               V_QTITEMPROD := V_QTPROGENTAF;
            END IF;*/
            
            IF (V_VRPREUNIAF > 0) THEN
               V_VRTOTALAF := V_VRTOTALAF + (V_QTITEMPROD * V_VRPREUNIAF);
            END IF;
         END LOOP;
         CLOSE C_ITEMPRODUTO;
      END LOOP;
      CLOSE C_AUTOFORN;
      
      V_NRAUTOFORNE := SUBSTR(V_NRAUTOFORNE, 1, LENGTH(V_NRAUTOFORNE)-1);
   END;
BEGIN
   SELECT LENGTH(REGEXP_REPLACE(P_CDFILIAL, '\d|[A-Z]'))
     INTO V_VERFILIAL
     FROM DUAL;
   
   WEBTUNNING(V_DSREMOTEADDR, V_DSREMOTEHOST, V_DSSERVERRDM, V_DSSERVMETHOD, V_DSREMOTEOPER);
   
   IF (P_IDTELAEXP = 'N') AND (V_DSREMOTEOPER <> 'VIA BD') THEN
      V_FECHDIA := 'S';
   ELSE
      V_FECHDIA := 'N';
   END IF;
   
   IF ((V_VERFILIAL > 2) OR (P_TCDFILIAL = 'T')) THEN
      FOR C_NOTAFISCAL IN
         (SELECT N.CDFILIAL, N.NRLANCTONF, N.CDFILIAL || N.NRLANCTONF CDUNICO, N.IDENTRSAIDOP, N.CDEMPRESA,
                 N.CDFILIRECE, N.CDTIPOOPER,
                 CASE WHEN N.NRINSJURNF IS NULL
                      THEN N.CDFORNECED
                      ELSE N.NRINSJURNF
                 END AS CDINSCRICAO,
                 CASE WHEN REGEXP_INSTR(CDSERIEENTR, '\D') > 0 THEN '0000' ELSE CDSERIEENTR END AS CDSERIE,
                 N.NRNOTAFISC, N.CDMODDOCFISC, N.DTEMISSAO, N.DTENTRSAID, N.NRACESSONFE, N.VRNOTAFISC,
                 N.NRSEQCAPADOC, N.DTENTRSAID AS DTCONTABILTG, T.IDORIGDESTOP, N.CDFILIEMIT,
                 CASE WHEN T.IDORIGDESTOP = 'L'
                      THEN 'CR'
                      ELSE NVL(T.IDORIGDESTOP, 'F')
                  END AS IDTPINSJURNF, N.NRPROTOCOLONFE,
                 TO_CHAR(N.DTHRPROTOCOLNFE, 'DD/MM/YYYY') AS DTAUTPROTOCOLO, TO_CHAR(N.DTHRPROTOCOLNFE, 'HH24:MI:SS') AS HRAUTPROTOCOLO,
                 DECODE(N.IDNFGERADAVIAXML, 'S', 'X',NULL) AS IDNFGERADAVIAXML, --NVL(PF.IDCONSREFECH, 'N') IDCONSREFECH,
                 F.IDFUNCAOFILI,
                 NVL(N.IDDOCREPLIC, N.DSNOTAFISORIGOL) ORIGEM,
                 N.CDIBGEORIG, N.CDIBGEDEST, NVL(PA.IDPROCNOTADEBCRE, 'N') IDPROCNOTADEBCRE
            FROM NOTAFISCAL N, PARAMFILIAL PF, FILIAL F, TIPOOPERAC T, FORNECEDOR FO, PARAMFORNE PA
           WHERE N.DTENTRSAID BETWEEN P_DATAINI AND (CASE WHEN P_IDTELAEXP = 'S'
                                                          THEN CASE WHEN (PF.DTPROCESSA  <= P_DATAFINAL)
                                                                    THEN PF.DTPROCESSA - 1
                                                                    ELSE TO_DATE(P_DATAFINAL)
                                                               END
                                                          ELSE TO_DATE(P_DATAFINAL)
                                                     END)
             AND ((INSTR(P_CDFILIAL, '_' || N.CDFILIRECE || '_') > 0) OR (P_TCDFILIAL = 'T'))
             AND ((INSTR(P_NUMERORE, N.NRSEQCAPADOC) > 0) OR (NVL(P_NUMERORE, 'T') = 'T'))
             AND N.CDFILIRECE   = PF.CDFILIAL
             AND N.CDFILIRECE   = F.CDFILIAL
             AND PF.CDFILIAL    = F.CDFILIAL
             AND N.IDENTRSAIDOP = T.IDENTRSAIDOP
             AND N.CDTIPOOPER   = T.CDTIPOOPER
             AND N.CDFORNECED   = FO.CDFORNECED(+)
             AND FO.CDFORNECED  = PA.CDFORNECED(+)
             AND N.CDMODDOCFISC IS NOT NULL
             AND N.NRSEQCAPADOC IS NOT NULL
             AND T.IDENTRSAIDOP = 'E'
             AND N.CDFILIAL||N.NRLANCTONF NOT IN (SELECT CDUNICO FROM USR_SAP_NOTAFISCAL)
             AND EXISTS (SELECT I.NRLANCTONF 
                           FROM ITEMPRODUTO I
                          WHERE I.CDFILIAL = N.CDFILIAL
                            AND I.NRLANCTONF = N.NRLANCTONF))
      LOOP
         --IF ((C_NOTAFISCAL.IDCONSREFECH = 'S') AND (C_NOTAFISCAL.NRSEQCAPADOC IS NOT NULL)) OR C_NOTAFISCAL.IDCONSREFECH = 'N' THEN
         V_FILIORIG := NULL;
         V_FILIDEST := NULL;
         V_VRTOTDIFNEGATIVO := 0;
         V_VRTOTDIFPOSITIVO := 0;
         BEGIN
            SELECT MAX(NF.NRNOTAFISC), MAX(NVL(NF.CDSERIE, NF.CDSERIEENTR))
              INTO V_NRLANCORIG, V_SERNFORIG
              FROM ITEMNOTAFISC IT, NOTAFISCAL NF, TIPOOPERAC T
             WHERE IT.CDFILIAL     = C_NOTAFISCAL.CDFILIAL
               AND IT.NRLANCTONF   = C_NOTAFISCAL.NRLANCTONF
               AND IT.CDFILIALIT   = NF.CDFILIAL
               AND IT.NRLANCTONFIT = NF.NRLANCTONF
               AND T.IDENTRSAIDOP = C_NOTAFISCAL.IDENTRSAIDOP
               AND T.CDTIPOOPER   = C_NOTAFISCAL.CDTIPOOPER
               AND T.IDOPERDEVONF = 'S';
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_NRLANCORIG := NULL;
               V_SERNFORIG  := NULL;
         END;
         
         IF C_NOTAFISCAL.IDORIGDESTOP = 'L' THEN
            V_FILIORIG := C_NOTAFISCAL.CDFILIRECE;
            V_FILIDEST := C_NOTAFISCAL.CDFILIEMIT;
            BEGIN
               SELECT NRPROTOCOLONFE, TO_CHAR(DTHRPROTOCOLNFE, 'DD/MM/YYYY') AS DTAUTPROTOCOLO, TO_CHAR(DTHRPROTOCOLNFE, 'HH24:MI:SS') AS HRAUTPROTOCOLO
                 INTO V_NRPROTOCOLONFE, V_DTAUTPROTOCOLO, V_HRAUTPROTOCOLO
                 FROM NOTAFISCAL
                WHERE CDFILIAL = SUBSTR(C_NOTAFISCAL.ORIGEM, 1, 4)
                  AND NRLANCTONF = SUBSTR(C_NOTAFISCAL.ORIGEM, 5, 10);
            EXCEPTION
               WHEN OTHERS THEN
                  V_NRPROTOCOLONFE := NULL;
                  V_DTAUTPROTOCOLO := NULL;
                  V_HRAUTPROTOCOLO := NULL;
            END;
         ELSE
            V_NRPROTOCOLONFE := C_NOTAFISCAL.NRPROTOCOLONFE;
            V_DTAUTPROTOCOLO := C_NOTAFISCAL.DTAUTPROTOCOLO;
            V_HRAUTPROTOCOLO := C_NOTAFISCAL.HRAUTPROTOCOLO;
         END IF;
         
         V_FILIALTG := GET_FILIALTG(C_NOTAFISCAL.CDFILIAL, C_NOTAFISCAL.NRLANCTONF);
         
         V_VRTOTALAF    := 0;
         V_VRDIFENFAF   := 0;
         V_CDFILDESTINO := '';
         V_CDFILLANCAME := '';
         V_NRAUTOFORNE  := '';
         BOAF := FALSE;
         
         VERIFICA_AF(C_NOTAFISCAL.CDFILIAL, C_NOTAFISCAL.NRLANCTONF, NVL(C_NOTAFISCAL.IDFUNCAOFILI, 'F'));
         IF (V_VRTOTALAF > 0) THEN
            V_VRDIFENFAF := (C_NOTAFISCAL.VRNOTAFISC - V_VRTOTALAF);
         END IF;
         
         INSERT INTO USR_SAP_NOTAFISCAL(CDUNICO, IDENTRSAID, CDEMPRESA, CDFILIAL, CDTIPOOPER,
                                        CDINSCRICAO, CDSERIE, NRNUMERO, CDMODELO, DTEMISSAO,
                                        DTENTRADA, NRACESSONFE, VRTOTALNF,
                                        IDINTERFACE, TPINTERFACE, DTINTERFACEORI, DTINTERFACEDEST, STATUS, APPORIGEM, APPDESTINO,
                                        DTPROC, DTCONTABILTG, NRNUMRETG,
                                        NRLANCTORIGNF, CDSERIEORIGNF, CDFILIORIG, CDFILIDEST, IDTPINSJURNF, NRPROTOCOLONFE, DTAUTPROTOCOLO, HRAUTPROTOCOLO,
                                        IDNFGERADAVIAXML, CDFILIALTG, CDOPERADOREXP, IDEXPORTFECHA, CDIBGEORIG, CDIBGEDEST,
                                        VRTOTALAF, /*VRDIFENFAF,*/ IDPROCNOTADEBCRE)
         VALUES (C_NOTAFISCAL.CDUNICO, C_NOTAFISCAL.IDENTRSAIDOP, C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.CDFILIRECE, C_NOTAFISCAL.CDTIPOOPER,
                 C_NOTAFISCAL.CDINSCRICAO, C_NOTAFISCAL.CDSERIE, C_NOTAFISCAL.NRNOTAFISC, C_NOTAFISCAL.CDMODDOCFISC, C_NOTAFISCAL.DTEMISSAO,
                 C_NOTAFISCAL.DTENTRSAID, C_NOTAFISCAL.NRACESSONFE, C_NOTAFISCAL.VRNOTAFISC,
                 USR_SAP_IDINTERFACE.NEXTVAL, 'I', SYSDATE, NULL, 1, 1, 2,
                 C_NOTAFISCAL.DTENTRSAID, C_NOTAFISCAL.DTCONTABILTG, C_NOTAFISCAL.NRSEQCAPADOC,
                 V_NRLANCORIG, V_SERNFORIG, V_FILIORIG, V_FILIDEST, C_NOTAFISCAL.IDTPINSJURNF, V_NRPROTOCOLONFE, V_DTAUTPROTOCOLO, V_HRAUTPROTOCOLO,
                 C_NOTAFISCAL.IDNFGERADAVIAXML, V_FILIALTG, V_DSREMOTEOPER, V_FECHDIA, C_NOTAFISCAL.CDIBGEORIG, C_NOTAFISCAL.CDIBGEDEST,
                 V_VRTOTALAF, /*V_VRDIFENFAF,*/ C_NOTAFISCAL.IDPROCNOTADEBCRE);

         FOR C_ITEMPROD IN
            (SELECT I.NRSEQITPROD, P.CDPRODUTO, I.QTITEMPROD, I.VRUNITITEM, I.VRDESCITEM, I.VRTOTAITEM,
                    I.CDALMOXARIFE, I.CDLOCALESTOQ, P.CDCLASFISC AS CDNCM, NVL(I.DSPRODEMIS, P.NMPRODUTO) AS DSPRODEMIS,
                    I.CDFISOPEITEM, I.CDSITUTRIBPR, I.CDMARCA, 
                    (NVL(I.VRFRETEITEM, 0) + NVL(I.VRSEGURITEM, 0) - NVL(I.VRENCARGODESC, 0) + NVL(I.VROUTRASDESPITEM, 0) + NVL(I.VRDESPADUANEIRA, 0)) IT_CALC_ENC
               FROM ITEMPRODUTO I, PRODUTO P
              WHERE I.CDFILIAL   = C_NOTAFISCAL.CDFILIAL
                AND I.NRLANCTONF = C_NOTAFISCAL.NRLANCTONF
                AND I.CDPRODUTO  = P.CDPRODUTO)
         LOOP
            V_VRTOTITEM_CALC := ((C_ITEMPROD.VRTOTAITEM - C_ITEMPROD.VRDESCITEM) /*C_ITEMPROD.QTITEMPROD*/); -- VALOR TOTAL - DESCONTO
            V_VRTOTITEM_CALC := (V_VRTOTITEM_CALC + C_ITEMPROD.IT_CALC_ENC); -- VALOR COM DESCONTO - ENCARGOS
            
            BEGIN
               SELECT NVL(DECODE(IDTRATIMPO, 'A', SUM(IT.VRIMPOSTOIT)),0) VRIMPOSTO_ACR,
                      NVL(DECODE(IDTRATIMPO, 'D', SUM(IT.VRIMPOSTOIT)),0) VRIMPOSTO_DEC
                 INTO V_IMPOSTO_ACR, V_IMPOSTO_DEC
                 FROM ITEMPROIMPOS IT, IMPOSTO IM
                WHERE IT.CDIMPOSTO    = IM.CDIMPOSTO
                  AND IT.CDFILIAL     = C_NOTAFISCAL.CDFILIAL
                  AND IT.NRLANCTONF   = C_NOTAFISCAL.NRLANCTONF
                  AND IT.NRSEQITPROD  = C_ITEMPROD.NRSEQITPROD
                  AND IT.NRITPROIMPOS = '1'
                  AND IM.IDTRATIMPO IN ('A', 'D')
                GROUP BY IDTRATIMPO;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_IMPOSTO_ACR := 0;
                  V_IMPOSTO_DEC := 0;
               WHEN OTHERS THEN
                  RAISE;
            END;
            
            V_VRTOTITEM_CALC := ROUND((V_VRTOTITEM_CALC + V_IMPOSTO_ACR - V_IMPOSTO_DEC), 5);
            
            V_CDARVPROD := GET_PRODUTO(C_ITEMPROD.CDPRODUTO, NVL(C_NOTAFISCAL.IDFUNCAOFILI, 'F'));
            IF BOAF THEN
               V_VRTOTAITEMAF := 0;
               V_VRDIFEITNFAF := 0;
               V_CDPRODUTO := PRODUTO_AF(V_CDARVPROD);
               V_NUMEROAF  := V_NRAUTOFORNE;
               V_CDFILDEST := V_CDFILDESTINO;
               V_CDFILLANC := V_CDFILLANCAME;
               
               WHILE (V_NUMEROAF IS NOT NULL) /*OR (V_VRTOTAITEMAF > 0)*/ LOOP
                  BEGIN
                     SELECT ROUND(VRPREUNIAF,5), QTPROGENTAF
                       INTO V_VRUNITAF, V_QTDEPRODAF
                       FROM ITEMAUTF
                      WHERE CDFILDEST  = SUBSTR(V_CDFILDEST, 1, 4)
                        AND CDFILLANC  = SUBSTR(V_CDFILLANC, 1, 4)
                        AND NRAUTOFORN = SUBSTR(V_NUMEROAF, 1, 10) --NUMERO DA AF DA SEQUENCIA --V_NRAUTOFORN
                        AND CDPRODUTO  = V_CDPRODUTO
                        AND CDMARCA    = C_ITEMPROD.CDMARCA;
                     
                     V_VRTOTAITEMAF := ROUND((V_VRUNITAF * C_ITEMPROD.QTITEMPROD),5);
                     V_VRDIFEITNFAF := ROUND((V_VRTOTITEM_CALC - V_VRTOTAITEMAF),5);
                     --V_VRDIFEITNFAF := (V_VRTOTAITEMAF - (C_ITEMPROD.VRTOTAITEM - C_ITEMPROD.VRDESCITEM));
                  EXCEPTION
                     WHEN OTHERS THEN
                        V_VRUNITAF := 0;
                  END;
                  
                  V_NUMEROAF  := SUBSTR(V_NUMEROAF, 12, LENGTH(V_NUMEROAF));
                  V_CDFILDEST := SUBSTR(V_CDFILDEST, 6, LENGTH(V_CDFILDEST));
                  V_CDFILLANC := SUBSTR(V_CDFILLANC, 6, LENGTH(V_CDFILLANC));
               END LOOP;
            ELSE
               V_VRUNITAF     := 0;
               V_VRTOTAITEMAF := 0;
               V_VRDIFEITNFAF := 0;
            END IF;
            
            IF V_VRDIFEITNFAF < 0 THEN
               V_VRTOTDIFNEGATIVO := V_VRTOTDIFNEGATIVO + V_VRDIFEITNFAF;
            ELSE
               V_VRTOTDIFPOSITIVO := V_VRTOTDIFPOSITIVO + V_VRDIFEITNFAF;
            END IF;
            
            V_VRUNITITEM_CALC := ROUND((V_VRTOTITEM_CALC / C_ITEMPROD.QTITEMPROD),5);
            
            INSERT INTO USR_SAP_ITEMPRODUTO(CDUNICO, NRSEQITEM, CDPRODUTO, VRQUANTIDADE,
                                            VRUNITARIO, VRDESCITEM, VRTOTAITEM, CDALMOXARIFADO, CDLOCALIZACAO,
                                            IDINTERFACE, TPINTERFACE, DTINTERFACEORI, DTINTERFACEDEST, STATUS, APPORIGEM, APPDESTINO, 
                                            CDNCM, DSPRODEMIS, CDCFOPITPROD, CDCSTITPROD,
                                            VRUNITAF, VRTOTAITEMAF, VRDIFEITNFAF, NRAUTOFORNE, QTPROGENTAF,
                                            VRUNITITEMCALC, VRTOTITEMCALC)
            VALUES (C_NOTAFISCAL.CDUNICO, C_ITEMPROD.NRSEQITPROD, V_CDARVPROD, C_ITEMPROD.QTITEMPROD,
                    C_ITEMPROD.VRUNITITEM, C_ITEMPROD.VRDESCITEM, C_ITEMPROD.VRTOTAITEM, C_ITEMPROD.CDALMOXARIFE, C_ITEMPROD.CDLOCALESTOQ,
                    USR_SAP_IDINTERFACE.NEXTVAL, 'I', SYSDATE, NULL, 1, 1, 2, 
                    C_ITEMPROD.CDNCM, C_ITEMPROD.DSPRODEMIS, C_ITEMPROD.CDFISOPEITEM, C_ITEMPROD.CDSITUTRIBPR,
                    V_VRUNITAF, V_VRTOTAITEMAF, (V_VRDIFEITNFAF * (-1)), SUBSTR(V_NRAUTOFORNE, 1, 300), V_QTDEPRODAF,
                    V_VRUNITITEM_CALC, V_VRTOTITEM_CALC);
                 
            FOR C_ITEMPROIMPOS IN
               (SELECT CDIMPOSTO, VRPERREDBCIT, VRBASECALCIT, VRALIQITEM, VRIMPOSTOIT, CDFISCALIT, CDSITUTRIBIT, CDSITUTRIBITNFE,
                       CASE WHEN SUBSTR(CDFISCOPERIT, 1, 1) = 1
                            THEN '5' || SUBSTR(CDFISCOPERIT, 2, LENGTH(CDFISCOPERIT))
                            WHEN SUBSTR(CDFISCOPERIT, 1, 1) = 2
                            THEN '6' || SUBSTR(CDFISCOPERIT, 2, LENGTH(CDFISCOPERIT))
                            WHEN SUBSTR(CDFISCOPERIT, 1, 1) = 3
                            THEN '7' || SUBSTR(CDFISCOPERIT, 2, LENGTH(CDFISCOPERIT))
                            ELSE CDFISCOPERIT
                       END AS CDFISCOPERIT,
                       NRITPROIMPOS, VRADICALIQFECP, VRADICFECP
                  FROM ITEMPROIMPOS
                 WHERE CDFILIAL = C_NOTAFISCAL.CDFILIAL
                   AND NRLANCTONF = C_NOTAFISCAL.NRLANCTONF
                   AND NRSEQITPROD = C_ITEMPROD.NRSEQITPROD)
            LOOP
               INSERT INTO USR_SAP_ITEMPROIMPOS(CDUNICO, NRSEQITEM, CDIMPOSTO, VRPERCRED, VRBASECALC,
                                                VRALIQUOTA, VRIMPOSTO, CDFISCALIT, CDSITUTRIB, CDFISCOPERIT, 
                                                IDINTERFACE, TPINTERFACE, DTINTERFACEORI, DTINTERFACEDEST, STATUS, APPORIGEM, APPDESTINO,
                                                NRITPROIMPOS, CDSITUTRIBITNFE, VRADICALIQFECP, VRADICFECP)
               VALUES (C_NOTAFISCAL.CDUNICO, C_ITEMPROD.NRSEQITPROD, C_ITEMPROIMPOS.CDIMPOSTO, C_ITEMPROIMPOS.VRPERREDBCIT, C_ITEMPROIMPOS.VRBASECALCIT,
                       C_ITEMPROIMPOS.VRALIQITEM, C_ITEMPROIMPOS.VRIMPOSTOIT, C_ITEMPROIMPOS.CDFISCALIT, C_ITEMPROIMPOS.CDSITUTRIBIT, C_ITEMPROIMPOS.CDFISCOPERIT, 
                       USR_SAP_IDINTERFACE.NEXTVAL, 'I', SYSDATE, NULL, 1, 1, 2,
                       C_ITEMPROIMPOS.NRITPROIMPOS, C_ITEMPROIMPOS.CDSITUTRIBITNFE, C_ITEMPROIMPOS.VRADICALIQFECP, C_ITEMPROIMPOS.VRADICFECP);
            END LOOP;
         END LOOP;
         
         UPDATE USR_SAP_NOTAFISCAL
            SET VRTOTDIFNEGATIVO = V_VRTOTDIFNEGATIVO,
                VRTOTDIFPOSITIVO = V_VRTOTDIFPOSITIVO,
                VRDIFENFAF       = V_VRTOTDIFNEGATIVO
          WHERE CDUNICO = C_NOTAFISCAL.CDUNICO;
         
         FOR C_ITEMENCARGO IN
            (SELECT CDENCARGO, VRITEMENCA
               FROM ITEMENCARGO
              WHERE CDFILIAL = C_NOTAFISCAL.CDFILIAL
                AND NRLANCTONF = C_NOTAFISCAL.NRLANCTONF)
         LOOP
            INSERT INTO USR_SAP_ITEMENCARGO(CDUNICO, CDENCARGO, VRENCARGO, IDINTERFACE, TPINTERFACE, DTINTERFACEORI, DTINTERFACEDEST, STATUS, APPORIGEM, APPDESTINO)
            VALUES (C_NOTAFISCAL.CDUNICO, C_ITEMENCARGO.CDENCARGO, C_ITEMENCARGO.VRITEMENCA, USR_SAP_IDINTERFACE.NEXTVAL, 'I', SYSDATE, NULL, 1, 1, 2);
         END LOOP;
         
         FOR C_VENCIMENTO IN
            (SELECT NRSEQVENPAG, NRPARCELAPAG, CDTPCTPAGAR, QTDIASVENPAG, DTORIGVENPAG, VRORIGPAG
               FROM CONTAPAGAR
              WHERE CDFILIAL   = C_NOTAFISCAL.CDFILIAL
                AND NRLANCTONF = C_NOTAFISCAL.NRLANCTONF)
         LOOP
            INSERT INTO USR_SAP_VENCIMENTOS(CDUNICO, NRSEQVEN, NRPARCELA, CDTIPOCONTA, QTDIASVEN,
                                            DTORIGVEN, VRORIGVEN, IDINTERFACE, TPINTERFACE, DTINTERFACEORI, DTINTERFACEDEST, STATUS, APPORIGEM, APPDESTINO)
            VALUES (C_NOTAFISCAL.CDUNICO, C_VENCIMENTO.NRSEQVENPAG, C_VENCIMENTO.NRPARCELAPAG, C_VENCIMENTO.CDTPCTPAGAR, C_VENCIMENTO.QTDIASVENPAG,
                    C_VENCIMENTO.DTORIGVENPAG, C_VENCIMENTO.VRORIGPAG, USR_SAP_IDINTERFACE.NEXTVAL, 'I', SYSDATE, NULL, 1, 1, 2);
         END LOOP;
         
         FOR C_DADOSADIC IN
            (SELECT NRDADOADIC, DSDADOADIC, CDMENSAGEM
               FROM DADOSADIC
              WHERE CDFILIAL   = C_NOTAFISCAL.CDFILIAL
                AND NRLANCTONF = C_NOTAFISCAL.NRLANCTONF)
         LOOP
            INSERT INTO USR_SAP_DADOSADIC(CDUNICO, NRDADOADIC, DSDADOSADIC, CDMENSAGEM,
                                          IDINTERFACE, TPINTERFACE, DTINTERFACEORI, DTINTERFACEDEST, STATUS, APPORIGEM, APPDESTINO)
            VALUES (C_NOTAFISCAL.CDUNICO, C_DADOSADIC.NRDADOADIC, C_DADOSADIC.DSDADOADIC, C_DADOSADIC.CDMENSAGEM,
                    USR_SAP_IDINTERFACE.NEXTVAL, 'I', SYSDATE, NULL, 1, 1, 2);
         END LOOP;
         COMMIT;
         --END IF;
      END LOOP;
   ELSE
      SELECT REPLACE(P_CDFILIAL, '_')
        INTO V_FILIAL
        FROM DUAL;

      FOR C_NOTAFISCAL IN
         (SELECT N.CDFILIAL, N.NRLANCTONF, N.CDFILIAL || N.NRLANCTONF CDUNICO, N.IDENTRSAIDOP, N.CDEMPRESA,
                 N.CDFILIRECE, N.CDTIPOOPER,
                 CASE WHEN N.NRINSJURNF IS NULL
                      THEN N.CDFORNECED
                      ELSE N.NRINSJURNF
                 END AS CDINSCRICAO,
                 CASE WHEN REGEXP_INSTR(CDSERIEENTR, '\D') > 0 THEN '0000' ELSE CDSERIEENTR END AS CDSERIE,
                 N.NRNOTAFISC, N.CDMODDOCFISC, N.DTEMISSAO, N.DTENTRSAID, N.NRACESSONFE, N.VRNOTAFISC,
                 N.NRSEQCAPADOC, N.DTENTRSAID AS DTCONTABILTG, T.IDORIGDESTOP, N.CDFILIEMIT,
                 CASE WHEN T.IDORIGDESTOP = 'L'
                      THEN 'CR'
                      ELSE NVL(T.IDORIGDESTOP, 'F')
                  END AS IDTPINSJURNF, N.NRPROTOCOLONFE,
                 TO_CHAR(N.DTHRPROTOCOLNFE, 'DD/MM/YYYY') AS DTAUTPROTOCOLO, TO_CHAR(N.DTHRPROTOCOLNFE, 'HH24:MI:SS') AS HRAUTPROTOCOLO,
                 DECODE(N.IDNFGERADAVIAXML, 'S', 'X',NULL) AS IDNFGERADAVIAXML, --NVL(PF.IDCONSREFECH, 'N') IDCONSREFECH,
                 F.IDFUNCAOFILI,
                 NVL(N.IDDOCREPLIC, N.DSNOTAFISORIGOL) ORIGEM,
                 N.CDIBGEORIG, N.CDIBGEDEST, NVL(PA.IDPROCNOTADEBCRE, 'N') IDPROCNOTADEBCRE
            FROM NOTAFISCAL N, PARAMFILIAL PF, FILIAL F, TIPOOPERAC T, FORNECEDOR FO, PARAMFORNE PA
           WHERE N.DTENTRSAID BETWEEN P_DATAINI AND (CASE WHEN P_IDTELAEXP = 'S'
                                                          THEN CASE WHEN (PF.DTPROCESSA  <= P_DATAFINAL)
                                                                    THEN PF.DTPROCESSA - 1
                                                                    ELSE TO_DATE(P_DATAFINAL)
                                                               END
                                                          ELSE TO_DATE(P_DATAFINAL)
                                                     END)
             AND CDFILIRECE     = V_FILIAL
             AND ((INSTR(P_NUMERORE, N.NRSEQCAPADOC) > 0) OR (NVL(P_NUMERORE, 'T') = 'T'))
             AND N.CDFILIRECE   = PF.CDFILIAL
             AND N.CDFILIRECE   = F.CDFILIAL
             AND PF.CDFILIAL    = F.CDFILIAL
             AND N.IDENTRSAIDOP = T.IDENTRSAIDOP
             AND N.CDTIPOOPER   = T.CDTIPOOPER
             AND N.CDFORNECED   = FO.CDFORNECED(+)
             AND FO.CDFORNECED  = PA.CDFORNECED(+)
             AND N.NRSEQCAPADOC IS NOT NULL
             AND N.CDMODDOCFISC IS NOT NULL
             AND T.IDENTRSAIDOP = 'E'
             AND N.CDFILIAL||N.NRLANCTONF NOT IN (SELECT CDUNICO FROM USR_SAP_NOTAFISCAL)
             AND EXISTS (SELECT I.NRLANCTONF
                           FROM ITEMPRODUTO I
                          WHERE I.CDFILIAL = N.CDFILIAL
                            AND I.NRLANCTONF = N.NRLANCTONF))
      LOOP
         --IF ((C_NOTAFISCAL.IDCONSREFECH = 'S') AND (C_NOTAFISCAL.NRSEQCAPADOC IS NOT NULL)) OR C_NOTAFISCAL.IDCONSREFECH = 'N' THEN
         V_FILIORIG := NULL;
         V_FILIDEST := NULL;
         V_VRTOTDIFNEGATIVO := 0;
         V_VRTOTDIFPOSITIVO := 0;
         BEGIN
            SELECT MAX(NF.NRNOTAFISC), MAX(NVL(NF.CDSERIE, NF.CDSERIEENTR))
              INTO V_NRLANCORIG, V_SERNFORIG
              FROM ITEMNOTAFISC IT, NOTAFISCAL NF, TIPOOPERAC T
             WHERE IT.CDFILIAL     = C_NOTAFISCAL.CDFILIAL
               AND IT.NRLANCTONF   = C_NOTAFISCAL.NRLANCTONF
               AND IT.CDFILIALIT   = NF.CDFILIAL
               AND IT.NRLANCTONFIT = NF.NRLANCTONF
               AND T.IDENTRSAIDOP = C_NOTAFISCAL.IDENTRSAIDOP
               AND T.CDTIPOOPER   = C_NOTAFISCAL.CDTIPOOPER
               AND T.IDOPERDEVONF = 'S';
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_NRLANCORIG := NULL;
               V_SERNFORIG  := NULL;
         END;
         
         IF C_NOTAFISCAL.IDORIGDESTOP = 'L' THEN
            V_FILIORIG := C_NOTAFISCAL.CDFILIRECE;
            V_FILIDEST := C_NOTAFISCAL.CDFILIEMIT;
            BEGIN
               SELECT NRPROTOCOLONFE, TO_CHAR(DTHRPROTOCOLNFE, 'DD/MM/YYYY') AS DTAUTPROTOCOLO, TO_CHAR(DTHRPROTOCOLNFE, 'HH24:MI:SS') AS HRAUTPROTOCOLO
                 INTO V_NRPROTOCOLONFE, V_DTAUTPROTOCOLO, V_HRAUTPROTOCOLO
                 FROM NOTAFISCAL
                WHERE CDFILIAL = SUBSTR(C_NOTAFISCAL.ORIGEM, 1, 4)
                  AND NRLANCTONF = SUBSTR(C_NOTAFISCAL.ORIGEM, 5, 10);                  
            EXCEPTION
               WHEN OTHERS THEN
                  V_NRPROTOCOLONFE := NULL;
                  V_DTAUTPROTOCOLO := NULL;
                  V_HRAUTPROTOCOLO := NULL;
            END;
         ELSE
            V_NRPROTOCOLONFE := C_NOTAFISCAL.NRPROTOCOLONFE;
            V_DTAUTPROTOCOLO := C_NOTAFISCAL.DTAUTPROTOCOLO;
            V_HRAUTPROTOCOLO := C_NOTAFISCAL.HRAUTPROTOCOLO;
         END IF;

         V_FILIALTG := GET_FILIALTG(C_NOTAFISCAL.CDFILIAL, C_NOTAFISCAL.NRLANCTONF);
         
         V_VRTOTALAF    := 0;
         V_VRDIFENFAF   := 0;
         V_CDFILDESTINO := '';
         V_CDFILLANCAME := '';
         V_NRAUTOFORNE  := '';
         BOAF := FALSE;
         
         VERIFICA_AF(C_NOTAFISCAL.CDFILIAL, C_NOTAFISCAL.NRLANCTONF, NVL(C_NOTAFISCAL.IDFUNCAOFILI, 'F'));
         IF (V_VRTOTALAF > 0) THEN
            V_VRDIFENFAF := (C_NOTAFISCAL.VRNOTAFISC - V_VRTOTALAF);
         END IF;
         
         INSERT INTO USR_SAP_NOTAFISCAL(CDUNICO, IDENTRSAID, CDEMPRESA, CDFILIAL, CDTIPOOPER,
                                        CDINSCRICAO, CDSERIE, NRNUMERO, CDMODELO, DTEMISSAO,
                                        DTENTRADA, NRACESSONFE, VRTOTALNF,
                                        IDINTERFACE, TPINTERFACE, DTINTERFACEORI, DTINTERFACEDEST, STATUS, APPORIGEM, APPDESTINO,
                                        DTPROC, DTCONTABILTG, NRNUMRETG,
                                        NRLANCTORIGNF, CDSERIEORIGNF, CDFILIORIG, CDFILIDEST, IDTPINSJURNF, NRPROTOCOLONFE, DTAUTPROTOCOLO, HRAUTPROTOCOLO,
                                        IDNFGERADAVIAXML, CDFILIALTG, CDOPERADOREXP, IDEXPORTFECHA, CDIBGEORIG, CDIBGEDEST,
                                        VRTOTALAF, /*VRDIFENFAF,*/ IDPROCNOTADEBCRE)
         VALUES (C_NOTAFISCAL.CDUNICO, C_NOTAFISCAL.IDENTRSAIDOP, C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.CDFILIRECE, C_NOTAFISCAL.CDTIPOOPER,
                 C_NOTAFISCAL.CDINSCRICAO, C_NOTAFISCAL.CDSERIE, C_NOTAFISCAL.NRNOTAFISC, C_NOTAFISCAL.CDMODDOCFISC, C_NOTAFISCAL.DTEMISSAO,
                 C_NOTAFISCAL.DTENTRSAID, C_NOTAFISCAL.NRACESSONFE, C_NOTAFISCAL.VRNOTAFISC,
                 USR_SAP_IDINTERFACE.NEXTVAL, 'I', SYSDATE, NULL, 1, 1, 2,
                 C_NOTAFISCAL.DTENTRSAID, C_NOTAFISCAL.DTCONTABILTG, C_NOTAFISCAL.NRSEQCAPADOC,
                 V_NRLANCORIG, V_SERNFORIG, V_FILIORIG, V_FILIDEST, C_NOTAFISCAL.IDTPINSJURNF, V_NRPROTOCOLONFE, V_DTAUTPROTOCOLO, V_HRAUTPROTOCOLO,
                 C_NOTAFISCAL.IDNFGERADAVIAXML, V_FILIALTG, V_DSREMOTEOPER, V_FECHDIA, C_NOTAFISCAL.CDIBGEORIG, C_NOTAFISCAL.CDIBGEDEST,
                 V_VRTOTALAF, /*V_VRDIFENFAF,*/ C_NOTAFISCAL.IDPROCNOTADEBCRE);
                     
         FOR C_ITEMPROD IN
            (SELECT I.NRSEQITPROD, P.CDPRODUTO, I.QTITEMPROD, I.VRUNITITEM, I.VRDESCITEM, I.VRTOTAITEM, 
                    I.CDALMOXARIFE, I.CDLOCALESTOQ, P.CDCLASFISC AS CDNCM, NVL(I.DSPRODEMIS, P.NMPRODUTO) AS DSPRODEMIS,
                    I.CDFISOPEITEM, I.CDSITUTRIBPR, I.CDMARCA,
                    (NVL(I.VRFRETEITEM, 0) + NVL(I.VRSEGURITEM, 0) - NVL(I.VRENCARGODESC, 0) + NVL(I.VROUTRASDESPITEM, 0) + NVL(I.VRDESPADUANEIRA, 0)) IT_CALC_ENC
               FROM ITEMPRODUTO I, PRODUTO P
              WHERE I.CDFILIAL   = C_NOTAFISCAL.CDFILIAL
                AND I.NRLANCTONF = C_NOTAFISCAL.NRLANCTONF
                AND I.CDPRODUTO  = P.CDPRODUTO)
         LOOP
            V_VRTOTITEM_CALC := ((C_ITEMPROD.VRTOTAITEM - C_ITEMPROD.VRDESCITEM) /*C_ITEMPROD.QTITEMPROD*/); -- VALOR TOTAL - DESCONTO
            V_VRTOTITEM_CALC := (V_VRTOTITEM_CALC + C_ITEMPROD.IT_CALC_ENC); -- VALOR COM DESCONTO - ENCARGOS
            
            BEGIN
               SELECT NVL(DECODE(IDTRATIMPO, 'A', SUM(IT.VRIMPOSTOIT)),0) VRIMPOSTO_ACR,
                      NVL(DECODE(IDTRATIMPO, 'D', SUM(IT.VRIMPOSTOIT)),0) VRIMPOSTO_DEC
                 INTO V_IMPOSTO_ACR, V_IMPOSTO_DEC
                 FROM ITEMPROIMPOS IT, IMPOSTO IM
                WHERE IT.CDIMPOSTO    = IM.CDIMPOSTO
                  AND IT.CDFILIAL     = C_NOTAFISCAL.CDFILIAL
                  AND IT.NRLANCTONF   = C_NOTAFISCAL.NRLANCTONF
                  AND IT.NRSEQITPROD  = C_ITEMPROD.NRSEQITPROD
                  AND IT.NRITPROIMPOS = '1'
                  AND IM.IDTRATIMPO IN ('A', 'D')
                GROUP BY IDTRATIMPO;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_IMPOSTO_ACR := 0;
                  V_IMPOSTO_DEC := 0;
               WHEN OTHERS THEN
                  RAISE;
            END;
            
            V_VRTOTITEM_CALC := ROUND((V_VRTOTITEM_CALC + V_IMPOSTO_ACR - V_IMPOSTO_DEC),5);
            
            V_CDARVPROD := GET_PRODUTO(C_ITEMPROD.CDPRODUTO, NVL(C_NOTAFISCAL.IDFUNCAOFILI, 'F'));
            IF BOAF THEN
               V_VRTOTAITEMAF := 0;
               V_VRDIFEITNFAF := 0;
               V_CDPRODUTO := PRODUTO_AF(V_CDARVPROD);
               V_NUMEROAF  := V_NRAUTOFORNE;
               V_CDFILDEST := V_CDFILDESTINO;
               V_CDFILLANC := V_CDFILLANCAME;
               
               WHILE (V_NUMEROAF IS NOT NULL) /*OR (V_VRTOTAITEMAF > 0)*/ LOOP
                  BEGIN
                     SELECT ROUND(VRPREUNIAF,5), QTPROGENTAF
                       INTO V_VRUNITAF, V_QTDEPRODAF
                       FROM ITEMAUTF
                      WHERE CDFILDEST  = SUBSTR(V_CDFILDEST, 1, 4)
                        AND CDFILLANC  = SUBSTR(V_CDFILLANC, 1, 4)
                        AND NRAUTOFORN = SUBSTR(V_NUMEROAF, 1, 10) --NUMERO DA AF DA SEQUENCIA --V_NRAUTOFORN
                        AND CDPRODUTO  = V_CDPRODUTO
                        AND CDMARCA    = C_ITEMPROD.CDMARCA;
                     
                     V_VRTOTAITEMAF := ROUND((V_VRUNITAF * C_ITEMPROD.QTITEMPROD),5);
                     V_VRDIFEITNFAF := ROUND((V_VRTOTAITEMAF - V_VRTOTITEM_CALC),5);
                     --V_VRDIFEITNFAF := (V_VRTOTAITEMAF - (C_ITEMPROD.VRTOTAITEM - C_ITEMPROD.VRDESCITEM));
                  EXCEPTION
                     WHEN OTHERS THEN
                        V_VRUNITAF := 0;
                  END;
                  
                  V_NUMEROAF  := SUBSTR(V_NUMEROAF, 12, LENGTH(V_NUMEROAF));
                  V_CDFILDEST := SUBSTR(V_CDFILDEST, 6, LENGTH(V_CDFILDEST));
                  V_CDFILLANC := SUBSTR(V_CDFILLANC, 6, LENGTH(V_CDFILLANC));
               END LOOP;
            ELSE
               V_VRUNITAF     := 0;
               V_VRTOTAITEMAF := 0;
               V_VRDIFEITNFAF := 0;
            END IF;
            
            IF V_VRDIFEITNFAF < 0 THEN
               V_VRTOTDIFNEGATIVO := V_VRTOTDIFNEGATIVO + V_VRDIFEITNFAF;
            ELSE
               V_VRTOTDIFPOSITIVO := V_VRTOTDIFPOSITIVO + V_VRDIFEITNFAF;
            END IF;
            
            V_VRUNITITEM_CALC := ROUND((V_VRTOTITEM_CALC / C_ITEMPROD.QTITEMPROD),5);
            
            INSERT INTO USR_SAP_ITEMPRODUTO(CDUNICO, NRSEQITEM, CDPRODUTO, VRQUANTIDADE, 
                                            VRUNITARIO, VRDESCITEM, VRTOTAITEM, CDALMOXARIFADO, CDLOCALIZACAO, 
                                            IDINTERFACE, TPINTERFACE, DTINTERFACEORI, DTINTERFACEDEST, STATUS, APPORIGEM, APPDESTINO,
                                            CDNCM, DSPRODEMIS, CDCFOPITPROD, CDCSTITPROD,
                                            VRUNITAF, VRTOTAITEMAF, VRDIFEITNFAF, NRAUTOFORNE, QTPROGENTAF,
                                            VRUNITITEMCALC, VRTOTITEMCALC)
            VALUES (C_NOTAFISCAL.CDUNICO, C_ITEMPROD.NRSEQITPROD, V_CDARVPROD, C_ITEMPROD.QTITEMPROD, 
                    C_ITEMPROD.VRUNITITEM, C_ITEMPROD.VRDESCITEM, C_ITEMPROD.VRTOTAITEM, C_ITEMPROD.CDALMOXARIFE, C_ITEMPROD.CDLOCALESTOQ, 
                    USR_SAP_IDINTERFACE.NEXTVAL, 'I', SYSDATE, NULL, 1, 1, 2,
                    C_ITEMPROD.CDNCM, C_ITEMPROD.DSPRODEMIS, C_ITEMPROD.CDFISOPEITEM, C_ITEMPROD.CDSITUTRIBPR,
                    V_VRUNITAF, V_VRTOTAITEMAF, (V_VRDIFEITNFAF * (-1)), SUBSTR(V_NRAUTOFORNE, 1, 300), V_QTDEPRODAF,
                    V_VRUNITITEM_CALC, V_VRTOTITEM_CALC);
                  
            FOR C_ITEMPROIMPOS IN
               (SELECT CDIMPOSTO, VRPERREDBCIT, VRBASECALCIT, VRALIQITEM, VRIMPOSTOIT, CDFISCALIT, CDSITUTRIBIT, CDSITUTRIBITNFE,
                       CASE WHEN SUBSTR(CDFISCOPERIT, 1, 1) = 1
                            THEN '5' || SUBSTR(CDFISCOPERIT, 2, LENGTH(CDFISCOPERIT))
                            WHEN SUBSTR(CDFISCOPERIT, 1, 1) = 2
                            THEN '6' || SUBSTR(CDFISCOPERIT, 2, LENGTH(CDFISCOPERIT))
                            WHEN SUBSTR(CDFISCOPERIT, 1, 1) = 3
                            THEN '7' || SUBSTR(CDFISCOPERIT, 2, LENGTH(CDFISCOPERIT))
                            ELSE CDFISCOPERIT
                       END AS CDFISCOPERIT,
                       NRITPROIMPOS, VRADICALIQFECP, VRADICFECP
                  FROM ITEMPROIMPOS
                 WHERE CDFILIAL = C_NOTAFISCAL.CDFILIAL
                   AND NRLANCTONF = C_NOTAFISCAL.NRLANCTONF
                   AND NRSEQITPROD = C_ITEMPROD.NRSEQITPROD)
            LOOP
               INSERT INTO USR_SAP_ITEMPROIMPOS(CDUNICO, NRSEQITEM, CDIMPOSTO, VRPERCRED, VRBASECALC,
                                                VRALIQUOTA, VRIMPOSTO, CDFISCALIT, CDSITUTRIB, CDFISCOPERIT,
                                                IDINTERFACE, TPINTERFACE, DTINTERFACEORI, DTINTERFACEDEST, STATUS, APPORIGEM, APPDESTINO,
                                                NRITPROIMPOS, CDSITUTRIBITNFE, VRADICALIQFECP, VRADICFECP)
               VALUES (C_NOTAFISCAL.CDUNICO, C_ITEMPROD.NRSEQITPROD, C_ITEMPROIMPOS.CDIMPOSTO, C_ITEMPROIMPOS.VRPERREDBCIT, C_ITEMPROIMPOS.VRBASECALCIT,
                       C_ITEMPROIMPOS.VRALIQITEM, C_ITEMPROIMPOS.VRIMPOSTOIT, C_ITEMPROIMPOS.CDFISCALIT, C_ITEMPROIMPOS.CDSITUTRIBIT, C_ITEMPROIMPOS.CDFISCOPERIT,
                       USR_SAP_IDINTERFACE.NEXTVAL, 'I', SYSDATE, NULL, 1, 1, 2,
                       C_ITEMPROIMPOS.NRITPROIMPOS, C_ITEMPROIMPOS.CDSITUTRIBITNFE, C_ITEMPROIMPOS.VRADICALIQFECP, C_ITEMPROIMPOS.VRADICFECP);
            END LOOP;
         END LOOP;
         
         UPDATE USR_SAP_NOTAFISCAL
            SET VRTOTDIFNEGATIVO = V_VRTOTDIFNEGATIVO,
                VRTOTDIFPOSITIVO = V_VRTOTDIFPOSITIVO,
                VRDIFENFAF       = V_VRTOTDIFNEGATIVO
          WHERE CDUNICO = C_NOTAFISCAL.CDUNICO;
         
         FOR C_ITEMENCARGO IN
            (SELECT CDENCARGO, VRITEMENCA
               FROM ITEMENCARGO
              WHERE CDFILIAL = C_NOTAFISCAL.CDFILIAL
                AND NRLANCTONF = C_NOTAFISCAL.NRLANCTONF)
         LOOP
            INSERT INTO USR_SAP_ITEMENCARGO(CDUNICO, CDENCARGO, VRENCARGO, IDINTERFACE, TPINTERFACE, DTINTERFACEORI, DTINTERFACEDEST, STATUS, APPORIGEM, APPDESTINO)
            VALUES (C_NOTAFISCAL.CDUNICO, C_ITEMENCARGO.CDENCARGO, C_ITEMENCARGO.VRITEMENCA, USR_SAP_IDINTERFACE.NEXTVAL, 'I', SYSDATE, NULL, 1, 1, 2);
         END LOOP;
         
         FOR C_VENCIMENTO IN
            (SELECT NRSEQVENPAG, NRPARCELAPAG, CDTPCTPAGAR, QTDIASVENPAG, DTORIGVENPAG, VRORIGPAG
               FROM CONTAPAGAR
              WHERE CDFILIAL   = C_NOTAFISCAL.CDFILIAL
                AND NRLANCTONF = C_NOTAFISCAL.NRLANCTONF)
         LOOP
            INSERT INTO USR_SAP_VENCIMENTOS(CDUNICO, NRSEQVEN, NRPARCELA, CDTIPOCONTA, QTDIASVEN,
                                            DTORIGVEN, VRORIGVEN, IDINTERFACE, TPINTERFACE, DTINTERFACEORI, DTINTERFACEDEST, STATUS, APPORIGEM, APPDESTINO)
            VALUES (C_NOTAFISCAL.CDUNICO, C_VENCIMENTO.NRSEQVENPAG, C_VENCIMENTO.NRPARCELAPAG, C_VENCIMENTO.CDTPCTPAGAR, C_VENCIMENTO.QTDIASVENPAG,
                    C_VENCIMENTO.DTORIGVENPAG, C_VENCIMENTO.VRORIGPAG, USR_SAP_IDINTERFACE.NEXTVAL, 'I', SYSDATE, NULL, 1, 1, 2);
         END LOOP;

         FOR C_DADOSADIC IN
            (SELECT NRDADOADIC, DSDADOADIC, CDMENSAGEM
               FROM DADOSADIC
              WHERE CDFILIAL   = C_NOTAFISCAL.CDFILIAL
                AND NRLANCTONF = C_NOTAFISCAL.NRLANCTONF)
         LOOP
            INSERT INTO USR_SAP_DADOSADIC(CDUNICO, NRDADOADIC, DSDADOSADIC, CDMENSAGEM,
                                          IDINTERFACE, TPINTERFACE, DTINTERFACEORI, DTINTERFACEDEST, STATUS, APPORIGEM, APPDESTINO)
            VALUES (C_NOTAFISCAL.CDUNICO, C_DADOSADIC.NRDADOADIC, C_DADOSADIC.DSDADOADIC, C_DADOSADIC.CDMENSAGEM,
                    USR_SAP_IDINTERFACE.NEXTVAL, 'I', SYSDATE, NULL, 1, 1, 2);
         END LOOP;
         COMMIT;
--         END IF;
      END LOOP;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('EXPORTA_NF_ENTRADA_SAP','6.45.003'); END;
/
