/* Tabela INSCRESTAD: */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na
tabela INSCRESTAD */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela INSCRESTAD utilizando a
tabela Geral de Logs de Operaes */

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'LOG_GER_INSCRESTAD' AND
                 TYPE   = 'TR' 		           AND
	              U.UID  = O.UID                AND
	              U.NAME = USER)
DROP TRIGGER LOG_GER_INSCRESTAD
GO

CREATE TRIGGER LOG_GER_INSCRESTAD
ON INSCRESTAD
FOR INSERT, UPDATE, DELETE
AS

   DECLARE  @V_USUARIO      VARCHAR(40);
   DECLARE  @V_TIPO         VARCHAR(1);
   DECLARE  @V_ITPESQ       VARCHAR(40);
   DECLARE  @V_DESC         VARCHAR(300);
   DECLARE  @V_CDFILLOGOPER VARCHAR(4);
   DECLARE  @V_DTOPER       DATETIME;

/*VARIVEIS DO CURSOR C_CURSOR*/

   DECLARE  @V_ID_COMANDO       VARCHAR(1);

   DECLARE  @V_CDEMPRESA_OLD    VARCHAR(2);
   DECLARE  @V_CDINSCESTA_OLD   VARCHAR(16);
   DECLARE  @V_NMREPRINSEST_OLD VARCHAR(40);
   DECLARE  @V_NRINSJURIEST_OLD VARCHAR(1);
   DECLARE  @V_CDCSTDIG1SAI_OLD VARCHAR(1);
   DECLARE  @V_DSENDEIEST_OLD   VARCHAR(50);
   DECLARE  @V_DSCOMPENDIES_OLD VARCHAR(200);
   DECLARE  @V_NRCEPIEST_OLD    VARCHAR(15);
   DECLARE  @V_CDPAIS_OLD       VARCHAR(4);
   DECLARE  @V_SGESTADO_OLD     VARCHAR(2);
   DECLARE  @V_CDBAIRRO_OLD     VARCHAR(10);
   DECLARE  @V_NMBAIRIEST_OLD   VARCHAR(30);
   DECLARE  @V_NRTELEIEST_OLD   VARCHAR(25);
   DECLARE  @V_NRFAXIEST_OLD    VARCHAR(25);
   DECLARE  @V_CDFILIAL_OLD     VARCHAR(4);
   DECLARE  @V_NRSERIECERTIFIC_OLD VARCHAR(50);
   DECLARE  @V_IDTPIMPRESDANFE_OLD VARCHAR(1);
   DECLARE  @V_IDTPAMBIENTENFE_OLD VARCHAR(1);
   DECLARE  @V_IDSUGREGSTENTR_OLD  VARCHAR(1);
   DECLARE  @V_CDENCARGOST_OLD     VARCHAR(2);
   DECLARE  @V_DTINIVIGIEST_OLD    DATETIME;
   DECLARE  @V_DTFIMVIGIEST_OLD    DATETIME;
   DECLARE  @V_IDCALCDIFENTFISC_OLD  VARCHAR(1);
   DECLARE  @V_IDCALCDIFENTFISC_NEW  VARCHAR(1);

   DECLARE  @V_CDEMPRESA_NEW    VARCHAR(2);
   DECLARE  @V_CDINSCESTA_NEW   VARCHAR(16);
   DECLARE  @V_NMREPRINSEST_NEW VARCHAR(40);
   DECLARE  @V_NRINSJURIEST_NEW VARCHAR(1);
   DECLARE  @V_CDCSTDIG1SAI_NEW VARCHAR(1);
   DECLARE  @V_DSENDEIEST_NEW   VARCHAR(50);
   DECLARE  @V_DSCOMPENDIES_NEW VARCHAR(200);
   DECLARE  @V_NRCEPIEST_NEW    VARCHAR(15);
   DECLARE  @V_CDPAIS_NEW       VARCHAR(4);
   DECLARE  @V_SGESTADO_NEW     VARCHAR(2);
   DECLARE  @V_CDBAIRRO_NEW     VARCHAR(10);
   DECLARE  @V_NMBAIRIEST_NEW   VARCHAR(30);
   DECLARE  @V_NRTELEIEST_NEW   VARCHAR(25);
   DECLARE  @V_NRFAXIEST_NEW    VARCHAR(25);
   DECLARE  @V_CDFILIAL_NEW     VARCHAR(4);
   DECLARE  @V_NRSERIECERTIFIC_NEW VARCHAR(50);
   DECLARE  @V_IDTPIMPRESDANFE_NEW VARCHAR(1);
   DECLARE  @V_IDTPAMBIENTENFE_NEW VARCHAR(1);
   DECLARE  @V_IDSUGREGSTENTR_NEW  VARCHAR(1);
   DECLARE  @V_CDENCARGOST_NEW     VARCHAR(2);
   DECLARE  @V_DTINIVIGIEST_NEW    DATETIME;
   DECLARE  @V_DTFIMVIGIEST_NEW    DATETIME;
BEGIN
   SET @V_TIPO = '0';
   SET @V_DESC = '';
   SET @V_CDFILLOGOPER = '';
   EXEC NMUSUARIO @V_USUARIO;
   SET @V_USUARIO = ISNULL(@V_USUARIO, '');

   DECLARE C_CURSOR CURSOR FOR
   SELECT 'D'
      IDCOMANDO,
      CDEMPRESA,
      CDINSCESTA,
      NMREPRINSEST,
      NRINSJURIEST,
      CDCSTDIG1SAI,
      DSENDEIEST,
      DSCOMPENDIES,
      NRCEPIEST ,
      CDPAIS,
      SGESTADO,
      CDBAIRRO,
      NMBAIRIEST,
      NRTELEIEST,
      NRFAXIEST,
      CDFILIAL,
      NRSERIECERTIFIC,
      IDTPIMPRESDANFE,
      IDTPAMBIENTENFE,    
      IDSUGREGSTENTR,
      CDENCARGOST,
      DTINIVIGIEST,
      DTFIMVIGIEST,
      IDCALCDIFENTFISC,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL

   FROM
      DELETED
   WHERE
      CDEMPRESA+CDINSCESTA NOT IN (SELECT CDEMPRESA+CDINSCESTA FROM INSERTED)

   UNION ALL

   SELECT
      'U'IDCOMANDO,
      DELETED.CDEMPRESA,
      DELETED.CDINSCESTA,
      DELETED.NMREPRINSEST,
      DELETED.NRINSJURIEST,
      DELETED.CDCSTDIG1SAI,
      DELETED.DSENDEIEST,
      DELETED.DSCOMPENDIES,
      DELETED.NRCEPIEST,
      DELETED.CDPAIS,
      DELETED.SGESTADO,
      DELETED.CDBAIRRO,
      DELETED.NMBAIRIEST,
      DELETED.NRTELEIEST,
      DELETED.NRFAXIEST,
      DELETED.CDFILIAL,
      DELETED.NRSERIECERTIFIC,
      DELETED.IDTPIMPRESDANFE,
      DELETED.IDTPAMBIENTENFE,
      DELETED.IDSUGREGSTENTR,
      DELETED.CDENCARGOST,
      DELETED.DTINIVIGIEST,
      DELETED.DTFIMVIGIEST,
      DELETED.IDCALCDIFENTFISC,

      INSERTED.CDEMPRESA,
      INSERTED.CDINSCESTA,
      INSERTED.NMREPRINSEST,
      INSERTED.NRINSJURIEST,
      INSERTED.CDCSTDIG1SAI,
      INSERTED.DSENDEIEST,
      INSERTED.DSCOMPENDIES,
      INSERTED.NRCEPIEST,
      INSERTED.CDPAIS,
      INSERTED.SGESTADO,
      INSERTED.CDBAIRRO,
      INSERTED.NMBAIRIEST,
      INSERTED.NRTELEIEST,
      INSERTED.NRFAXIEST,
      INSERTED.CDFILIAL,
      INSERTED.NRSERIECERTIFIC,
      INSERTED.IDTPIMPRESDANFE,
      INSERTED.IDTPAMBIENTENFE,
      INSERTED.IDSUGREGSTENTR,
      INSERTED.CDENCARGOST,
      INSERTED.DTINIVIGIEST,
      INSERTED.DTFIMVIGIEST,
      INSERTED.IDCALCDIFENTFISC
   FROM
      INSERTED,DELETED
   WHERE
      INSERTED.CDEMPRESA  = DELETED.CDEMPRESA AND
      INSERTED.CDINSCESTA = DELETED.CDINSCESTA

   UNION ALL
   SELECT
      'I' IDCOMANDO,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      CDEMPRESA,
      CDINSCESTA,
      NMREPRINSEST,
      NRINSJURIEST,
      CDCSTDIG1SAI,
      DSENDEIEST,
      DSCOMPENDIES,
      NRCEPIEST,
      CDPAIS,
      SGESTADO,
      CDBAIRRO,
      NMBAIRIEST,
      NRTELEIEST,
      NRFAXIEST,
      CDFILIAL,
      NRSERIECERTIFIC,
      IDTPIMPRESDANFE,
      IDTPAMBIENTENFE,
      IDSUGREGSTENTR,
      CDENCARGOST,
      DTINIVIGIEST,
      DTFIMVIGIEST,
      IDCALCDIFENTFISC

   FROM
      INSERTED
   WHERE
      CDEMPRESA+CDINSCESTA NOT IN (SELECT CDEMPRESA+CDINSCESTA FROM DELETED);

   OPEN C_CURSOR;
   FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                 @V_CDEMPRESA_OLD,
                                 @V_CDINSCESTA_OLD,
                                 @V_NMREPRINSEST_OLD,
                                 @V_NRINSJURIEST_OLD,
                                 @V_CDCSTDIG1SAI_OLD,
                                 @V_DSENDEIEST_OLD,
                                 @V_DSCOMPENDIES_OLD,
                                 @V_NRCEPIEST_OLD,
                                 @V_CDPAIS_OLD,
                                 @V_SGESTADO_OLD,
                                 @V_CDBAIRRO_OLD,
                                 @V_NMBAIRIEST_OLD,
                                 @V_NRTELEIEST_OLD,
                                 @V_NRFAXIEST_OLD,
                                 @V_CDFILIAL_OLD,
                                 @V_NRSERIECERTIFIC_OLD,
                                 @V_IDTPIMPRESDANFE_OLD,
                                 @V_IDTPAMBIENTENFE_OLD,
                                 @V_IDSUGREGSTENTR_OLD,
                                 @V_CDENCARGOST_OLD,
                                 @V_DTINIVIGIEST_OLD,
                                 @V_DTFIMVIGIEST_OLD,
                                 @V_IDCALCDIFENTFISC_OLD,

                                 @V_CDEMPRESA_NEW,
                                 @V_CDINSCESTA_NEW,
                                 @V_NMREPRINSEST_NEW,
                                 @V_NRINSJURIEST_NEW,
                                 @V_CDCSTDIG1SAI_NEW,
                                 @V_DSENDEIEST_NEW,
                                 @V_DSCOMPENDIES_NEW,
                                 @V_NRCEPIEST_NEW,
                                 @V_CDPAIS_NEW,
                                 @V_SGESTADO_NEW,
                                 @V_CDBAIRRO_NEW,
                                 @V_NMBAIRIEST_NEW,
                                 @V_NRTELEIEST_NEW,
                                 @V_NRFAXIEST_NEW,
                                 @V_CDFILIAL_NEW,
                                 @V_NRSERIECERTIFIC_NEW,
                                 @V_IDTPIMPRESDANFE_NEW,
                                 @V_IDTPAMBIENTENFE_NEW,
                                 @V_IDSUGREGSTENTR_NEW,
                                 @V_CDENCARGOST_NEW,
                                 @V_DTINIVIGIEST_NEW,
                                 @V_DTFIMVIGIEST_NEW,
                                 @V_IDCALCDIFENTFISC_NEW;

   WHILE (@@FETCH_STATUS = 0) BEGIN
      IF @V_ID_COMANDO = 'D' /*DELETING*/BEGIN
         IF @V_CDEMPRESA_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'CDEmpresa=' + @V_CDEMPRESA_OLD;
         END;

         IF @V_CDINSCESTA_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Cod=' + @V_CDINSCESTA_OLD;
         END;

         IF @V_NMREPRINSEST_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' ReprLegal=' + @V_NMREPRINSEST_OLD;
         END;

         IF @V_NRINSJURIEST_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Inscr=' + @V_NRINSJURIEST_OLD;
         END;

         IF @V_CDCSTDIG1SAI_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' DigitoCST=' + @V_CDCSTDIG1SAI_OLD;
         END;

         IF @V_DSENDEIEST_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Endereco=' + @V_DSENDEIEST_OLD;
         END;

         IF @V_DSCOMPENDIES_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Complemento=' + @V_DSCOMPENDIES_OLD;
         END;

         IF @V_NRCEPIEST_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' CEP=' + @V_NRCEPIEST_OLD;
         END;

         IF @V_CDPAIS_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Pais=' + @V_CDPAIS_OLD;
         END;

         IF @V_SGESTADO_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' SGEstado=' + @V_SGESTADO_OLD;
         END;

         IF @V_CDBAIRRO_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Bairro=' + @V_CDBAIRRO_OLD;
         END;

         IF @V_NMBAIRIEST_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' NmBairro=' + @V_NMBAIRIEST_OLD;
         END;

         IF @V_NRTELEIEST_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Tel.=' + @V_NRTELEIEST_OLD;
         END;

         IF @V_NRFAXIEST_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Fax=' + @V_NRFAXIEST_OLD;
         END;

         IF @V_NRSERIECERTIFIC_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Num.Certificado='  + @V_NRSERIECERTIFIC_OLD;
         END;

         IF @V_IDTPIMPRESDANFE_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Impr.Danfe='  + @V_IDTPIMPRESDANFE_OLD;
         END;

         IF @V_IDTPAMBIENTENFE_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' AmbienteNFE='  + @V_IDTPAMBIENTENFE_OLD;
         END;

         IF @V_IDSUGREGSTENTR_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' RegimeST=' + @V_IDSUGREGSTENTR_OLD;
         END;

         IF @V_CDENCARGOST_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' EncargoST=' + @V_CDENCARGOST_OLD;
         END;

         IF @V_DTINIVIGIEST_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' VigenciaIni=' + @V_DTINIVIGIEST_OLD;
         END;

         IF @V_DTFIMVIGIEST_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' VigenciaFim=' + @V_DTFIMVIGIEST_OLD;
         END;

         IF @V_IDCALCDIFENTFISC_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' CalcDifalImpD=' + @V_IDCALCDIFENTFISC_OLD;
         END;

         SET @V_TIPO         = '3';
         SET @V_ITPESQ       = @V_CDEMPRESA_OLD + @V_CDINSCESTA_OLD;
         SET @V_CDFILLOGOPER = @V_CDFILIAL_OLD;
      END
      ELSE IF @V_ID_COMANDO= 'U' /*UPDATING*/ BEGIN
         IF (@V_CDEMPRESA_OLD    <> @V_CDEMPRESA_NEW)    OR
            (@V_CDINSCESTA_OLD   <> @V_CDINSCESTA_NEW)   OR
            (@V_NMREPRINSEST_OLD <> @V_NMREPRINSEST_NEW) OR
            (@V_NRINSJURIEST_OLD <> @V_NRINSJURIEST_NEW) OR
            (@V_CDCSTDIG1SAI_OLD <> @V_CDCSTDIG1SAI_NEW) OR
            (@V_DSENDEIEST_OLD   <> @V_DSENDEIEST_NEW)   OR
            (@V_DSCOMPENDIES_OLD <> @V_DSCOMPENDIES_NEW) OR
            (@V_NRCEPIEST_OLD    <> @V_NRCEPIEST_NEW)    OR
            (@V_CDPAIS_OLD       <> @V_CDPAIS_NEW)       OR
            (@V_SGESTADO_OLD     <> @V_SGESTADO_NEW)     OR
            (@V_CDBAIRRO_OLD     <> @V_CDBAIRRO_NEW)     OR
            (@V_NMBAIRIEST_OLD   <> @V_NMBAIRIEST_NEW)   OR
            (@V_NRTELEIEST_OLD   <> @V_NRTELEIEST_NEW)   OR
            (@V_NRFAXIEST_OLD    <> @V_NRFAXIEST_NEW)    OR
            (@V_NRSERIECERTIFIC_OLD <> @V_NRSERIECERTIFIC_NEW) OR
            (@V_IDTPIMPRESDANFE_OLD <> @V_IDTPIMPRESDANFE_NEW) OR
            (@V_IDTPAMBIENTENFE_OLD <> @V_IDTPAMBIENTENFE_NEW) OR
            (@V_IDSUGREGSTENTR_OLD  <> @V_IDSUGREGSTENTR_NEW)  OR
            (@V_CDENCARGOST_OLD     <> @V_CDENCARGOST_NEW)     OR
            (@V_DTINIVIGIEST_OLD    <> @V_DTINIVIGIEST_NEW)    OR
            (@V_IDCALCDIFENTFISC_OLD <> @V_IDCALCDIFENTFISC_NEW) OR
            (@V_DTFIMVIGIEST_OLD    <> @V_DTFIMVIGIEST_NEW) BEGIN

            SET @V_TIPO         = '2';
            SET @V_ITPESQ       = @V_CDEMPRESA_OLD+@V_CDINSCESTA_OLD;
            SET @V_CDFILLOGOPER = @V_CDFILIAL_OLD;
         END;
      END
      ELSE BEGIN
         SET @V_TIPO         = '1';
         SET @V_ITPESQ       = @V_CDEMPRESA_NEW+@V_CDINSCESTA_NEW;
         SET @V_CDFILLOGOPER = @V_CDFILIAL_NEW;
      END;
      IF ISNULL(@V_CDEMPRESA_NEW, '!') <> ISNULL(@V_CDEMPRESA_OLD, '!') BEGIN
         SET @V_DESC = @V_DESC + 'CDEmpresa=' + @V_CDEMPRESA_NEW;
      END;

      IF ISNULL(@V_CDINSCESTA_NEW, '!') <> ISNULL(@V_CDEMPRESA_OLD, '!') BEGIN
         SET @V_DESC = @V_DESC + ' Cod=' + @V_CDINSCESTA_NEW;
      END;

      IF ISNULL(@V_NMREPRINSEST_NEW, '!') <> ISNULL(@V_NMREPRINSEST_NEW, '!') BEGIN
         SET @V_DESC = @V_DESC + ' ReprLegal=' + @V_NMREPRINSEST_NEW;
      END;

      IF ISNULL(@V_NRINSJURIEST_NEW, '!') <> ISNULL(@V_NRINSJURIEST_OLD, '!') BEGIN
         SET @V_DESC = @V_DESC + ' Inscr=' + @V_NRINSJURIEST_NEW;
      END;

      IF ISNULL(@V_CDCSTDIG1SAI_NEW, '!') <> ISNULL(@V_CDCSTDIG1SAI_OLD, '!') BEGIN
         SET @V_DESC = @V_DESC + ' DigitoCST=' + @V_CDCSTDIG1SAI_NEW;
      END;

      IF ISNULL(@V_DSENDEIEST_NEW, '!') <> ISNULL(@V_DSENDEIEST_OLD, '!') BEGIN
         SET @V_DESC = @V_DESC + ' Endereco=' + @V_DSENDEIEST_NEW;
      END;

      IF ISNULL(@V_DSCOMPENDIES_NEW, '!') <> ISNULL(@V_DSCOMPENDIES_OLD, '!') BEGIN
         SET @V_DESC = @V_DESC + ' Complemento=' + @V_DSCOMPENDIES_NEW;
      END;

      IF ISNULL(@V_NRCEPIEST_NEW, '!') <> ISNULL(@V_NRCEPIEST_OLD, '!')  BEGIN
         SET @V_DESC = @V_DESC + ' CEP=' + @V_NRCEPIEST_NEW;
      END;

      IF ISNULL(@V_CDPAIS_NEW, '!') <> ISNULL(@V_CDPAIS_NEW, '!') BEGIN
         SET @V_DESC = @V_DESC + ' Pais=' + @V_CDPAIS_NEW;
      END;

      IF ISNULL(@V_SGESTADO_NEW, '!') <> ISNULL(@V_SGESTADO_OLD, '!') BEGIN
         SET @V_DESC = @V_DESC + ' SGEstado=' + @V_SGESTADO_NEW;
      END;

      IF ISNULL(@V_CDBAIRRO_NEW, '!') <> ISNULL(@V_CDBAIRRO_OLD, '!') BEGIN
         SET @V_DESC = @V_DESC + ' Bairro=' + @V_CDBAIRRO_NEW;
      END;

      IF ISNULL(@V_NMBAIRIEST_NEW, '!') <> ISNULL(@V_NMBAIRIEST_OLD, '!') BEGIN
         SET @V_DESC = @V_DESC + ' NMBairro=' + @V_NMBAIRIEST_NEW;
      END;

      IF ISNULL(@V_NRTELEIEST_NEW, '!') <> ISNULL(@V_NRTELEIEST_OLD, '!') BEGIN
         SET @V_DESC = @V_DESC + ' Tel.=' + @V_NRTELEIEST_NEW;
      END;

      IF ISNULL(@V_NRFAXIEST_NEW, '!') <> ISNULL(@V_NRFAXIEST_OLD, '!') BEGIN
         SET @V_DESC = @V_DESC + ' Fax=' + @V_NRFAXIEST_NEW;
      END;

      IF ISNULL(@V_NRSERIECERTIFIC_NEW, '!') <> ISNULL(@V_NRSERIECERTIFIC_OLD, '!') BEGIN
         SET @V_DESC = @V_DESC + ' Num.Certificado='  + @V_NRSERIECERTIFIC_NEW;
      END;

      IF ISNULL(@V_IDTPIMPRESDANFE_NEW, '!') <> ISNULL(@V_IDTPIMPRESDANFE_OLD, '!') BEGIN
         SET @V_DESC = @V_DESC + ' Impr.Danfe='  + @V_IDTPIMPRESDANFE_NEW;
      END;

      IF ISNULL(@V_IDTPAMBIENTENFE_NEW, '!') <> ISNULL(@V_IDTPAMBIENTENFE_OLD, '!') BEGIN
         SET @V_DESC = @V_DESC + ' AmbienteNFE='  + @V_IDTPAMBIENTENFE_NEW;
      END;

      IF ISNULL(@V_IDSUGREGSTENTR_NEW, '!') <> ISNULL(@V_IDSUGREGSTENTR_OLD, '!') BEGIN
         SET @V_DESC = @V_DESC + ' RegimeST='  + @V_IDSUGREGSTENTR_NEW;
      END;                       

      IF ISNULL(@V_CDENCARGOST_NEW, '!') <> ISNULL(@V_CDENCARGOST_OLD, '!') BEGIN
         SET @V_DESC = @V_DESC + ' EncargoST='  + @V_CDENCARGOST_NEW;
      END;

      IF (@V_DTINIVIGIEST_NEW IS NOT NULL) AND (@V_DTINIVIGIEST_NEW <> @V_DTINIVIGIEST_OLD) BEGIN
         SET @V_DESC = @V_DESC + ' VigenciaIni=' + CONVERT(VARCHAR,@V_DTINIVIGIEST_NEW);
      END;

      IF (@V_DTFIMVIGIEST_NEW IS NOT NULL) AND (@V_DTFIMVIGIEST_NEW <> @V_DTFIMVIGIEST_OLD) BEGIN
         SET @V_DESC = @V_DESC + ' VigenciaFim=' + CONVERT(VARCHAR,@V_DTFIMVIGIEST_NEW);
      END;

      IF ISNULL(@V_IDCALCDIFENTFISC_NEW, '!') <> ISNULL(@V_IDCALCDIFENTFISC_OLD, '!') BEGIN
         SET @V_DESC = @V_DESC + ' CalcDifalImpD='  + @V_IDCALCDIFENTFISC_NEW;
      END;

      IF @V_TIPO <> '0' BEGIN
         EXEC NMUSUARIO @V_USUARIO;
         IF NOT @V_DESC IS NULL BEGIN
            IF NOT @V_USUARIO IS NULL BEGIN
               SET @V_DTOPER = GETDATE();

               INSERT INTO LOGOPERA
                  (NMTABELA,   DTOPERACAO, NMRESPOPER,
                   IDTIPOOPER, CDPESQITEM, DSOPERACAO, CDFILLOGOPER)
               VALUES
                  ('INSCRESTAD',  @V_DTOPER, @V_USUARIO,
                   @V_TIPO,      @V_ITPESQ, @V_DESC, @V_CDFILLOGOPER);
            END;
         END;
      END;
   FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                 @V_CDEMPRESA_OLD,
                                 @V_CDINSCESTA_OLD,
                                 @V_NMREPRINSEST_OLD,
                                 @V_NRINSJURIEST_OLD,
                                 @V_CDCSTDIG1SAI_OLD,
                                 @V_DSENDEIEST_OLD,
                                 @V_DSCOMPENDIES_OLD,
                                 @V_NRCEPIEST_OLD,
                                 @V_CDPAIS_OLD,
                                 @V_SGESTADO_OLD,
                                 @V_CDBAIRRO_OLD,
                                 @V_NMBAIRIEST_OLD,
                                 @V_NRTELEIEST_OLD,
                                 @V_NRFAXIEST_OLD,
                                 @V_CDFILIAL_OLD,
                                 @V_NRSERIECERTIFIC_OLD,
                                 @V_IDTPIMPRESDANFE_OLD,
                                 @V_IDTPAMBIENTENFE_OLD,
                                 @V_IDSUGREGSTENTR_OLD,
                                 @V_CDENCARGOST_OLD,
                                 @V_DTINIVIGIEST_OLD,
                                 @V_DTFIMVIGIEST_OLD,
                                 @V_IDCALCDIFENTFISC_OLD,

                                 @V_CDEMPRESA_NEW,
                                 @V_CDINSCESTA_NEW,
                                 @V_NMREPRINSEST_NEW,
                                 @V_NRINSJURIEST_NEW,
                                 @V_CDCSTDIG1SAI_NEW,
                                 @V_DSENDEIEST_NEW,
                                 @V_DSCOMPENDIES_NEW,
                                 @V_NRCEPIEST_NEW,
                                 @V_CDPAIS_NEW,
                                 @V_SGESTADO_NEW,
                                 @V_CDBAIRRO_NEW,
                                 @V_NMBAIRIEST_NEW,
                                 @V_NRTELEIEST_NEW,
                                 @V_NRFAXIEST_NEW,
                                 @V_CDFILIAL_NEW,
                                 @V_NRSERIECERTIFIC_NEW,
                                 @V_IDTPIMPRESDANFE_NEW,
                                 @V_IDTPAMBIENTENFE_NEW,
                                 @V_IDSUGREGSTENTR_NEW,
                                 @V_CDENCARGOST_NEW,
                                 @V_DTINIVIGIEST_NEW,
                                 @V_DTFIMVIGIEST_NEW,
                                 @V_IDCALCDIFENTFISC_NEW;


   END;
   CLOSE      C_CURSOR;
   DEALLOCATE C_CURSOR;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'LOG_GER_INSCRESTAD','6.19.XXX';
GO







